use num_integer::Integer;

fn main() {
	// sample sets
	let sample_1: Vec<i32> = vec![46, 69, 32, 60, 52, 41];
	let sample_2: Vec<u8> = vec![66, 30, 40, 64];
	let sample_3: Vec<u16> = vec![51, 21, 79, 49];
	
	//results
	//result 1
	println!("sample 1");
	let result_1 = standard_deviation(sample_1, false);
	println!("standard deviation: {}", result_1);
	
	//result 2
	println!("sample 2");
	let result_2 = standard_deviation(sample_2, true);
	println!("standard deviation: {}", result_2);
	
	//result 3
	println!("sample 3");
	let result_3 = standard_deviation(sample_3, false);
	println!("standard deviation: {}", result_3);
}

/// This function returns the standard deviation of a vector.
///
/// There is a optional paramiter to return a more conservitive
/// guess for working with samples of a bigger set.
///
/// This is a hackjob and should not be used it only works on
/// integers and would need a overload to support Floats, can't
/// be bothered to rewrite this.
fn standard_deviation<T>(input: Vec<T>, sample_part_of_set: bool) -> f64
where
	T: std::fmt::Debug + Integer + Copy + std::iter::Sum + Into<f64>,
{
	let sample_set: Vec<T> = input.clone();
	let sample_len: i64 = sample_set.len() as i64;
	let sample_sum: T = sample_set.iter().copied().sum();
	let sample_mean: f64 = sample_sum.into() / sample_len as f64;
	let standard_deviation: f64 = (sample_set
		.iter()
		.map(|input| (((*input).into() - sample_mean) as f64).powf(2.))
		.collect::<Vec<f64>>()
		.iter()
		.sum::<f64>()
		/ (sample_len - sample_part_of_set as i64) as f64)
		.sqrt();
	standard_deviation
}
